% Jesse Checkla & Alice Kassar
% Method A - Alice Kassar Detection Method
% Cornell MEng ECE - Spring 2015

clear
delete(instrfind);

% Create the Serial Object:
s = serial('COM4','BaudRate',9600);
fopen(s);

% Generate all possible sequences
p1(1,:,1)=[1 0 0 1 0 0 1 0 0 0];
p1(2,:,1)=[0 1 0 0 1 0 0 0 1 1];
p1(3,:,1)=[0 0 1 0 0 1 0 1 0 0];
% 
% p2(1,:,1)=[1 0 1 1 0 1 0 0 0 0 0 0];
% p2(2,:,1)=[0 1 0 0 0 0 0 0 1 0 1 1];
% p2(3,:,1)=[0 0 0 0 1 0 1 1 0 1 0 0];

p2(1,:,1)=[1 0 0 0 0 0 0 1 0 1 1];
p2(2,:,1)=[0 1 1 0 1 0 0 0 0 0 0];
p2(3,:,1)=[0 0 0 1 0 1 1 0 1 0 0];

p3(1,:,1)=[1 1 1 1 0 0 0 0 0 0 0 0];
p3(2,:,1)=[0 0 0 0 1 1 0 0 0 0 1 1];
p3(3,:,1)=[0 0 0 0 0 0 1 1 1 1 0 0];

% Generate all possible rotations:
p1=rotatepattern(p1);
p2=rotatepattern(p2);
p3=rotatepattern(p3);

% variables of p1
testp1=p1;
ballscount1=0;
validsqce1=nan;
holdball1=-1;
stop1=0;
flagsqce1=0;

%variables of p2
testp2=p2;
ballscount2=0;
validsqce2=nan;
holdball2=-1;
stop2=0;
flagsqce2=0;

%variables of p3
testp3=p3;
ballscount3=0;
validsqce3=nan;
holdball3=-1;
stop3=0;
flagsqce3=0;

ballsequence=[];
%ballsequence=p1(1,:,1)*1+p1(2,:,1)*2+p1(3,:,1)*3;
%ballsequence=p3(1,:,1)*1+p3(2,:,1)*2+p3(3,:,1)*3;
%ballsequence=p2(1,:,1)*3+p2(2,:,1)*1+p2(3,:,1)*2;
k=0;
counter=0;
patterneliminated=0;
state=1;
previouspattern=nan;
fprintf(s,'%c','z');
while(1)
    
    value=[];
    while(isempty(value))
        if s.BytesAvailable ~= 0;
            value=fscanf(s,'%s');
            valueint=str2num(value);
            counter=counter+1;
        end
    end
    
    if state==1
        if(counter>3)
            %if(~isempty(ballsequence) )
            state=2;
        end
        
    elseif state==2
        ballsequence=[ballsequence, valueint]
        k=k+1;
        if stop1==0
            [testp1 validsqce1 ballscount1 holdball1 flag1 flagsqce1]=...
                testpattern(ballsequence(k), k, p1, testp1, validsqce1,...
                ballscount1, holdball1,flagsqce1);
            if flag1==1
                'not pattern1'
                stop1=1;
                patterneliminated=patterneliminated+1;
            end
        end
        
        
        if stop2==0
            [testp2 validsqce2 ballscount2 holdball2 flag2 flagsqce2]=...
                testpattern(ballsequence(k), k, p2, testp2, validsqce2,...
                ballscount2, holdball2,flagsqce2);
            if flag2==1
                'not pattern2'
                stop2=1;
                patterneliminated=patterneliminated+1;
            end
        end
        
        if stop3==0
            [testp3 validsqce3 ballscount3 holdball3 flag3 flagsqce3]=...
                testpattern(ballsequence(k), k, p3, testp3, validsqce3,...
                ballscount3, holdball3, flagsqce3);
            if flag3==1
                'not pattern3'
                stop3=1;
                patterneliminated=patterneliminated+1;
                
            end
        end
        
        if( patterneliminated>=2)
            if stop1==0
                stop1=1;
                if(isnan(previouspattern) || previouspattern==1)
                    'pattern1'
                    fprintf(s,'%c','a');
                else
                    'changing pattern to 1'
                end
                previouspattern=1;
                
                
            elseif stop2==0
                stop2=1;
                if(isnan(previouspattern) || previouspattern==2)
                    'pattern2'
                    fprintf(s,'%c','c');
                else
                    'changing pattern to 2'
                end
                previouspattern=2;
                
                
            elseif stop3==0
                stop3=1;
                if(isnan(previouspattern) || previouspattern==3)
                    'pattern3'
                    fprintf(s,'%c','b');
                else
                    'changing pattern to 3'
                end
                previouspattern=3;
            else
                'undetected pattern'
            end
            
            % variables of p1
            testp1=p1;
            ballscount1=0;
            validsqce1=nan;
            holdball1=-1;
            stop1=0;
            flagsqce1=0;
            
            %variables of p2
            testp2=p2;
            ballscount2=0;
            validsqce2=nan;
            holdball2=-1;
            stop2=0;
            flagsqce2=0;
            
            %varialbes of p3
            testp3=p3;
            ballscount3=0;
            validsqce3=nan;
            holdball3=-1;
            stop3=0;
            flagsqce3=0;
              
            ballsequence=[];
            k=0;
            counter=0;
            patterneliminated=0;
        end
        
    end
    
end
